<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Surface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_surface.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="class_surface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Surface Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A base class for every geometry class (e.g., <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>, <a class="el" href="class_triangle.html" title="A class to create and manipulate triangles. ">Triangle</a>, <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>).  
 <a href="class_surface.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_surface_8hpp_source.html">Surface.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Surface:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_surface.png" usemap="#Surface_map" alt=""/>
  <map id="Surface_map" name="Surface_map">
<area href="class_mesh.html" title="A class to create and manipulate triangular meshes. " alt="Mesh" shape="rect" coords="0,56,58,80"/>
<area href="class_sphere.html" title="A class to create and manipulate spheres. " alt="Sphere" shape="rect" coords="68,56,126,80"/>
<area href="class_triangle.html" title="A class to create and manipulate triangles. " alt="Triangle" shape="rect" coords="136,56,194,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a66c78e81a329eee37ddad0dece149b96"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">Surface</a> (<a class="el" href="class_material.html">Material</a> *&amp;_m)</td></tr>
<tr class="memdesc:a66c78e81a329eee37ddad0dece149b96"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> constructor. This is not supposed to be called directly by the user.  <a href="#a66c78e81a329eee37ddad0dece149b96">More...</a><br /></td></tr>
<tr class="separator:a66c78e81a329eee37ddad0dece149b96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8fc57f2a15292135c00545c9d224ec68"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a8fc57f2a15292135c00545c9d224ec68">Surface</a> ()</td></tr>
<tr class="separator:a8fc57f2a15292135c00545c9d224ec68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89de75c95cb550d432f3ea4ed1429db0"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a89de75c95cb550d432f3ea4ed1429db0">~Surface</a> ()</td></tr>
<tr class="separator:a89de75c95cb550d432f3ea4ed1429db0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab59cc271b2fe0db25867fc16664cc22f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">setID</a> (std::string _id)</td></tr>
<tr class="memdesc:ab59cc271b2fe0db25867fc16664cc22f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a unique identifier for this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="#ab59cc271b2fe0db25867fc16664cc22f">More...</a><br /></td></tr>
<tr class="separator:ab59cc271b2fe0db25867fc16664cc22f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab13775c761a7b51a95b57d300b94a9c8"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">isSmoothShaded</a> ()</td></tr>
<tr class="memdesc:ab13775c761a7b51a95b57d300b94a9c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this surface should be renderered with smooth shading.  <a href="#ab13775c761a7b51a95b57d300b94a9c8">More...</a><br /></td></tr>
<tr class="separator:ab13775c761a7b51a95b57d300b94a9c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae844c2766ec89af9dd6e65db59cf0b02"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">setSmoothShading</a> (bool _smooth_shading)</td></tr>
<tr class="memdesc:ae844c2766ec89af9dd6e65db59cf0b02"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this surface should be renderered with smooth shading.  <a href="#ae844c2766ec89af9dd6e65db59cf0b02">More...</a><br /></td></tr>
<tr class="separator:ae844c2766ec89af9dd6e65db59cf0b02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab04a7e3f5f5b51061b014bdbcfd85107"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">getVertexPosLocalCoords</a> (int _i)</td></tr>
<tr class="memdesc:ab04a7e3f5f5b51061b014bdbcfd85107"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="#ab04a7e3f5f5b51061b014bdbcfd85107">More...</a><br /></td></tr>
<tr class="separator:ab04a7e3f5f5b51061b014bdbcfd85107"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80450b9cb334e067ddaacb4380149c8e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">getVertexPosWorldCoords</a> (int _i)</td></tr>
<tr class="memdesc:a80450b9cb334e067ddaacb4380149c8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the i-th vertex in the world frame (after being affected by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> hierarchy).  <a href="#a80450b9cb334e067ddaacb4380149c8e">More...</a><br /></td></tr>
<tr class="separator:a80450b9cb334e067ddaacb4380149c8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a455dca43c650016886ea02320ed4a3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">setVertexPosLocalCoords</a> (int _i, <a class="el" href="class_vec.html">Vec</a> _pos)</td></tr>
<tr class="memdesc:a7a455dca43c650016886ea02320ed4a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="#a7a455dca43c650016886ea02320ed4a3">More...</a><br /></td></tr>
<tr class="separator:a7a455dca43c650016886ea02320ed4a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ffcbcea002fc72862411a3edbd386a7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_material.html">Material</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">getMaterial</a> ()</td></tr>
<tr class="memdesc:a1ffcbcea002fc72862411a3edbd386a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="#a1ffcbcea002fc72862411a3edbd386a7">More...</a><br /></td></tr>
<tr class="separator:a1ffcbcea002fc72862411a3edbd386a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2110a2eb3f0279d59a52e2034069eaae"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">setMaterial</a> (<a class="el" href="class_material.html">Material</a> *_m)</td></tr>
<tr class="memdesc:a2110a2eb3f0279d59a52e2034069eaae"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> (via a pointer).  <a href="#a2110a2eb3f0279d59a52e2034069eaae">More...</a><br /></td></tr>
<tr class="separator:a2110a2eb3f0279d59a52e2034069eaae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1dabf409cbd72a6cf1984a21304369ff"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a1dabf409cbd72a6cf1984a21304369ff">bounding_box</a> ()</td></tr>
<tr class="memdesc:a1dabf409cbd72a6cf1984a21304369ff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes an Axis-Aligned Bounding <a class="el" href="class_box.html">Box</a> that encompasses all vertexes of this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="#a1dabf409cbd72a6cf1984a21304369ff">More...</a><br /></td></tr>
<tr class="separator:a1dabf409cbd72a6cf1984a21304369ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3cf222676c208dc301ffc1dacb028e1"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_box.html">Box</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ae3cf222676c208dc301ffc1dacb028e1">getBBox</a> ()</td></tr>
<tr class="memdesc:ae3cf222676c208dc301ffc1dacb028e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the bounding box of this surface.  <a href="#ae3cf222676c208dc301ffc1dacb028e1">More...</a><br /></td></tr>
<tr class="separator:ae3cf222676c208dc301ffc1dacb028e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b0c1c392cc14642a7ff88db7c16d0f0"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a1b0c1c392cc14642a7ff88db7c16d0f0">getCentroid</a> ()</td></tr>
<tr class="memdesc:a1b0c1c392cc14642a7ff88db7c16d0f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the centroid of this surface.  <a href="#a1b0c1c392cc14642a7ff88db7c16d0f0">More...</a><br /></td></tr>
<tr class="separator:a1b0c1c392cc14642a7ff88db7c16d0f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad5b74adad1504d73dbed6e47bc011bca"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ad5b74adad1504d73dbed6e47bc011bca">hit</a> (const <a class="el" href="class_ray.html">Ray</a> &amp;r, <a class="el" href="structhit__rec.html">hit_rec</a> &amp;h_r, double t_min, double t_max)</td></tr>
<tr class="separator:ad5b74adad1504d73dbed6e47bc011bca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abcbeb2a388e4971bd7095ce57e85fb95"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">setTransform</a> (<a class="el" href="class_transform.html">Transform</a> *_tf)</td></tr>
<tr class="memdesc:abcbeb2a388e4971bd7095ce57e85fb95"><td class="mdescLeft">&#160;</td><td class="mdescRight">Associates a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. The method <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a> can then be used to change the <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s pose/scale based on _tf.  <a href="#abcbeb2a388e4971bd7095ce57e85fb95">More...</a><br /></td></tr>
<tr class="separator:abcbeb2a388e4971bd7095ce57e85fb95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25a12923766c3df006fa32628fe6bd4b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">getTransform</a> ()</td></tr>
<tr class="memdesc:a25a12923766c3df006fa32628fe6bd4b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node associated with this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> through method setTransform.  <a href="#a25a12923766c3df006fa32628fe6bd4b">More...</a><br /></td></tr>
<tr class="separator:a25a12923766c3df006fa32628fe6bd4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10655735b685f4363df818a2c6fdfb9b"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b">transform</a> ()</td></tr>
<tr class="memdesc:a10655735b685f4363df818a2c6fdfb9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the application of the transform provided with <a class="el" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95" title="Associates a Transform node to this Surface. The method transform() can then be used to change the Su...">setTransform()</a> to all <a class="el" href="class_vertex.html" title="A class to create and manipulate 3D vertexes. ">Vertex</a> objects associated to this surface.  <a href="#a10655735b685f4363df818a2c6fdfb9b">More...</a><br /></td></tr>
<tr class="separator:a10655735b685f4363df818a2c6fdfb9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6eaec7d61d4a87ce7cd42089487850bf"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a6eaec7d61d4a87ce7cd42089487850bf">addSurfaces</a> (std::vector&lt; <a class="el" href="class_surface.html">Surface</a> *&gt; &amp;objects)</td></tr>
<tr class="memdesc:a6eaec7d61d4a87ce7cd42089487850bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds this surface (its pointer, actually) to a given vector of surfaces.  <a href="#a6eaec7d61d4a87ce7cd42089487850bf">More...</a><br /></td></tr>
<tr class="separator:a6eaec7d61d4a87ce7cd42089487850bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:ac8918f57a731e9f129c4a2051d0bc15d"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_vertex.html">Vertex</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">vertexes</a></td></tr>
<tr class="memdesc:ac8918f57a731e9f129c4a2051d0bc15d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector of vertexes associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Derived classes must use this vector if bounding boxes and transforms are to be applied.  <a href="#ac8918f57a731e9f129c4a2051d0bc15d">More...</a><br /></td></tr>
<tr class="separator:ac8918f57a731e9f129c4a2051d0bc15d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60490e6d2fe723957e8814289f538624"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a60490e6d2fe723957e8814289f538624">id</a></td></tr>
<tr class="memdesc:a60490e6d2fe723957e8814289f538624"><td class="mdescLeft">&#160;</td><td class="mdescRight">A string containing a unique ID for the surface.  <a href="#a60490e6d2fe723957e8814289f538624">More...</a><br /></td></tr>
<tr class="separator:a60490e6d2fe723957e8814289f538624"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d1534766e141346af770b5e95503bf"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a65d1534766e141346af770b5e95503bf">b_box_def</a></td></tr>
<tr class="memdesc:a65d1534766e141346af770b5e95503bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating if a bounding box has been defined already.  <a href="#a65d1534766e141346af770b5e95503bf">More...</a><br /></td></tr>
<tr class="separator:a65d1534766e141346af770b5e95503bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99bb89c6eeea7dd90b3fda098b51422b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_material.html">Material</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">m</a></td></tr>
<tr class="memdesc:a99bb89c6eeea7dd90b3fda098b51422b"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this surface.  <a href="#a99bb89c6eeea7dd90b3fda098b51422b">More...</a><br /></td></tr>
<tr class="separator:a99bb89c6eeea7dd90b3fda098b51422b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7675dc7633490a99cd39620054e2bdb"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">smooth_shading</a></td></tr>
<tr class="memdesc:aa7675dc7633490a99cd39620054e2bdb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating if Phong interpolation is to be used.  <a href="#aa7675dc7633490a99cd39620054e2bdb">More...</a><br /></td></tr>
<tr class="separator:aa7675dc7633490a99cd39620054e2bdb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3cebceee209a3762a5dc2550d69064c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">local_n</a></td></tr>
<tr class="memdesc:ad3cebceee209a3762a5dc2550d69064c"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the local frame of reference (computed elsewhere)  <a href="#ad3cebceee209a3762a5dc2550d69064c">More...</a><br /></td></tr>
<tr class="separator:ad3cebceee209a3762a5dc2550d69064c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7df9cc390062b02fa30e18eaea47dc3b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">n</a></td></tr>
<tr class="memdesc:a7df9cc390062b02fa30e18eaea47dc3b"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the global frame of reference - updated with <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a>  <a href="#a7df9cc390062b02fa30e18eaea47dc3b">More...</a><br /></td></tr>
<tr class="separator:a7df9cc390062b02fa30e18eaea47dc3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a676d836b2651caf205065fcd095a356b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_box.html">Box</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a676d836b2651caf205065fcd095a356b">b_box</a></td></tr>
<tr class="memdesc:a676d836b2651caf205065fcd095a356b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Bounding box (a <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> itself - currently a <a class="el" href="class_box.html">Box</a>) encompassing all vertexes of this surface.  <a href="#a676d836b2651caf205065fcd095a356b">More...</a><br /></td></tr>
<tr class="separator:a676d836b2651caf205065fcd095a356b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a444077659d77f2e034ae163cbb103134"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a444077659d77f2e034ae163cbb103134">tf</a></td></tr>
<tr class="memdesc:a444077659d77f2e034ae163cbb103134"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Set this variable with setTransform.  <a href="#a444077659d77f2e034ae163cbb103134">More...</a><br /></td></tr>
<tr class="separator:a444077659d77f2e034ae163cbb103134"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A base class for every geometry class (e.g., <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>, <a class="el" href="class_triangle.html" title="A class to create and manipulate triangles. ">Triangle</a>, <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>). </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a66c78e81a329eee37ddad0dece149b96"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66c78e81a329eee37ddad0dece149b96">&sect;&nbsp;</a></span>Surface() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Surface::Surface </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&amp;&#160;</td>
          <td class="paramname"><em>_m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> constructor. This is not supposed to be called directly by the user. </p>

</div>
</div>
<a id="a8fc57f2a15292135c00545c9d224ec68"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8fc57f2a15292135c00545c9d224ec68">&sect;&nbsp;</a></span>Surface() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Surface::Surface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a89de75c95cb550d432f3ea4ed1429db0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a89de75c95cb550d432f3ea4ed1429db0">&sect;&nbsp;</a></span>~Surface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Surface::~Surface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6eaec7d61d4a87ce7cd42089487850bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6eaec7d61d4a87ce7cd42089487850bf">&sect;&nbsp;</a></span>addSurfaces()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Surface::addSurfaces </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> *&gt; &amp;&#160;</td>
          <td class="paramname"><em>objects</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds this surface (its pointer, actually) to a given vector of surfaces. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">objects</td><td>The vector of surfaces that will receive this surface. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="class_triangle.html#a78d01c00d6c3ddd7cd15b7d8270622fa">Triangle</a>, <a class="el" href="class_sphere.html#a52b2eaae5dac35fa93b5e254af875828">Sphere</a>, and <a class="el" href="class_mesh.html#afa6d51dcd0b3636a992b509621afef87">Mesh</a>.</p>

</div>
</div>
<a id="a1dabf409cbd72a6cf1984a21304369ff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1dabf409cbd72a6cf1984a21304369ff">&sect;&nbsp;</a></span>bounding_box()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Surface::bounding_box </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Computes an Axis-Aligned Bounding <a class="el" href="class_box.html">Box</a> that encompasses all vertexes of this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. </p>

<p>Reimplemented in <a class="el" href="class_mesh.html#a0560f1ba7ad6b24a176ab302723b0fa2">Mesh</a>, <a class="el" href="class_triangle.html#a021fb26d1e764935add59709d8b1112f">Triangle</a>, and <a class="el" href="class_sphere.html#a8e7068ae2787aa9ff47eefe23b245c9f">Sphere</a>.</p>

</div>
</div>
<a id="ae3cf222676c208dc301ffc1dacb028e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3cf222676c208dc301ffc1dacb028e1">&sect;&nbsp;</a></span>getBBox()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="class_box.html">Box</a> Surface::getBBox </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the bounding box of this surface. </p>
<dl class="section return"><dt>Returns</dt><dd>The bounding box of this surface. </dd></dl>

<p>Reimplemented in <a class="el" href="class_mesh.html#acc5d10d24bcc8b127ce9033cf01cb73b">Mesh</a>, <a class="el" href="class_triangle.html#a8d4b4ef6090fb1bc4ceec217ff8991ec">Triangle</a>, and <a class="el" href="class_sphere.html#ab5aec7813daccf5bca5831cde5a30c00">Sphere</a>.</p>

</div>
</div>
<a id="a1b0c1c392cc14642a7ff88db7c16d0f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1b0c1c392cc14642a7ff88db7c16d0f0">&sect;&nbsp;</a></span>getCentroid()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="class_vec.html">Vec</a> Surface::getCentroid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the centroid of this surface. </p>
<dl class="section return"><dt>Returns</dt><dd>The centroid of this surface. </dd></dl>

<p>Reimplemented in <a class="el" href="class_mesh.html#aed5f345616e0d840eb59e1f4a0c77df9">Mesh</a>, <a class="el" href="class_triangle.html#ae7c4f3cf55493686d174ff4196477739">Triangle</a>, and <a class="el" href="class_sphere.html#af245199d60ad587999c8b4e10f2c8dc0">Sphere</a>.</p>

</div>
</div>
<a id="a1ffcbcea002fc72862411a3edbd386a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ffcbcea002fc72862411a3edbd386a7">&sect;&nbsp;</a></span>getMaterial()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_material.html">Material</a>* Surface::getMaterial </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. </p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. </dd></dl>

</div>
</div>
<a id="a25a12923766c3df006fa32628fe6bd4b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a25a12923766c3df006fa32628fe6bd4b">&sect;&nbsp;</a></span>getTransform()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_transform.html">Transform</a>* Surface::getTransform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node associated with this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> through method setTransform. </p>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node. </dd></dl>

</div>
</div>
<a id="ab04a7e3f5f5b51061b014bdbcfd85107"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab04a7e3f5f5b51061b014bdbcfd85107">&sect;&nbsp;</a></span>getVertexPosLocalCoords()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Surface::getVertexPosLocalCoords </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_i</td><td>The index of the vertex to be queried. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The position of the i-th vertex in the object frame. </dd></dl>

</div>
</div>
<a id="a80450b9cb334e067ddaacb4380149c8e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a80450b9cb334e067ddaacb4380149c8e">&sect;&nbsp;</a></span>getVertexPosWorldCoords()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Surface::getVertexPosWorldCoords </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the position of the i-th vertex in the world frame (after being affected by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> hierarchy). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_i</td><td>The index of the vertex to be queried. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The position of the i-th vertex in the world frame. </dd></dl>

</div>
</div>
<a id="ad5b74adad1504d73dbed6e47bc011bca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5b74adad1504d73dbed6e47bc011bca">&sect;&nbsp;</a></span>hit()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Surface::hit </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a> &amp;&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Triggers the intersection tests over all geometry contained in this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> and a given <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>. Here, this method does nothing. Derived Classes (e.g., <a class="el" href="class_triangle.html" title="A class to create and manipulate triangles. ">Triangle</a>) must implement it.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">r</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> to be tested </td></tr>
    <tr><td class="paramname">h_r</td><td>Hit record that stores the information regarding the first intersection between r and the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>'s geometry </td></tr>
    <tr><td class="paramname">t_min</td><td>Controls the closest allowed intersection </td></tr>
    <tr><td class="paramname">t_max</td><td>Controls the furthest allowed intersection </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="class_sphere.html#afb9d78112a4d75bff15caf6d4e7d0362">Sphere</a>, <a class="el" href="class_triangle.html#a07aa3c7813a34fd89441344130262b44">Triangle</a>, and <a class="el" href="class_mesh.html#abb73d5cb7028e1138cb714b34d01bbca">Mesh</a>.</p>

</div>
</div>
<a id="ab13775c761a7b51a95b57d300b94a9c8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab13775c761a7b51a95b57d300b94a9c8">&sect;&nbsp;</a></span>isSmoothShaded()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Surface::isSmoothShaded </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a boolean stating whether this surface should be renderered with smooth shading. </p>
<dl class="section return"><dt>Returns</dt><dd>A boolean stating whether this surface should be renderered with smooth shading. </dd></dl>

</div>
</div>
<a id="ab59cc271b2fe0db25867fc16664cc22f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab59cc271b2fe0db25867fc16664cc22f">&sect;&nbsp;</a></span>setID()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Surface::setID </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a unique identifier for this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>The unique identifier. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2110a2eb3f0279d59a52e2034069eaae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2110a2eb3f0279d59a52e2034069eaae">&sect;&nbsp;</a></span>setMaterial()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Surface::setMaterial </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>_m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> (via a pointer). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_m</td><td>A pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> to be associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="class_mesh.html#a216201cebabdd7341983615e19239c94">Mesh</a>.</p>

</div>
</div>
<a id="ae844c2766ec89af9dd6e65db59cf0b02"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae844c2766ec89af9dd6e65db59cf0b02">&sect;&nbsp;</a></span>setSmoothShading()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Surface::setSmoothShading </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_smooth_shading</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets a boolean stating whether this surface should be renderered with smooth shading. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_smooth_shading</td><td>A boolean stating whether this surface should be renderered with smooth shading. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="abcbeb2a388e4971bd7095ce57e85fb95"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abcbeb2a388e4971bd7095ce57e85fb95">&sect;&nbsp;</a></span>setTransform()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Surface::setTransform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>_tf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Associates a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. The method <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a> can then be used to change the <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s pose/scale based on _tf. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_tf</td><td>Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="class_mesh.html#a3a5773b7b3f1457e0e1667a8b5c49975">Mesh</a>.</p>

</div>
</div>
<a id="a7a455dca43c650016886ea02320ed4a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7a455dca43c650016886ea02320ed4a3">&sect;&nbsp;</a></span>setVertexPosLocalCoords()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Surface::setVertexPosLocalCoords </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>_i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_i</td><td>The index of the vertex to be updated. </td></tr>
    <tr><td class="paramname">_pos</td><td>The position of the i-th vertex in the object frame. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a10655735b685f4363df818a2c6fdfb9b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a10655735b685f4363df818a2c6fdfb9b">&sect;&nbsp;</a></span>transform()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Surface::transform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Triggers the application of the transform provided with <a class="el" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95" title="Associates a Transform node to this Surface. The method transform() can then be used to change the Su...">setTransform()</a> to all <a class="el" href="class_vertex.html" title="A class to create and manipulate 3D vertexes. ">Vertex</a> objects associated to this surface. </p>

<p>Reimplemented in <a class="el" href="class_mesh.html#afca381025e36aeaf6dcab4f8aa89113c">Mesh</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a676d836b2651caf205065fcd095a356b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a676d836b2651caf205065fcd095a356b">&sect;&nbsp;</a></span>b_box</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_box.html">Box</a>* Surface::b_box</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Bounding box (a <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> itself - currently a <a class="el" href="class_box.html">Box</a>) encompassing all vertexes of this surface. </p>

</div>
</div>
<a id="a65d1534766e141346af770b5e95503bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65d1534766e141346af770b5e95503bf">&sect;&nbsp;</a></span>b_box_def</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Surface::b_box_def</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating if a bounding box has been defined already. </p>

</div>
</div>
<a id="a60490e6d2fe723957e8814289f538624"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a60490e6d2fe723957e8814289f538624">&sect;&nbsp;</a></span>id</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string Surface::id</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A string containing a unique ID for the surface. </p>

</div>
</div>
<a id="ad3cebceee209a3762a5dc2550d69064c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3cebceee209a3762a5dc2550d69064c">&sect;&nbsp;</a></span>local_n</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Surface::local_n</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the local frame of reference (computed elsewhere) </p>

</div>
</div>
<a id="a99bb89c6eeea7dd90b3fda098b51422b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99bb89c6eeea7dd90b3fda098b51422b">&sect;&nbsp;</a></span>m</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_material.html">Material</a>* Surface::m</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this surface. </p>

</div>
</div>
<a id="a7df9cc390062b02fa30e18eaea47dc3b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7df9cc390062b02fa30e18eaea47dc3b">&sect;&nbsp;</a></span>n</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Surface::n</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the global frame of reference - updated with <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a> </p>

</div>
</div>
<a id="aa7675dc7633490a99cd39620054e2bdb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa7675dc7633490a99cd39620054e2bdb">&sect;&nbsp;</a></span>smooth_shading</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Surface::smooth_shading</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating if Phong interpolation is to be used. </p>

</div>
</div>
<a id="a444077659d77f2e034ae163cbb103134"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a444077659d77f2e034ae163cbb103134">&sect;&nbsp;</a></span>tf</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_transform.html">Transform</a>* Surface::tf</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Set this variable with setTransform. </p>

</div>
</div>
<a id="ac8918f57a731e9f129c4a2051d0bc15d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac8918f57a731e9f129c4a2051d0bc15d">&sect;&nbsp;</a></span>vertexes</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_vertex.html">Vertex</a>*&gt; Surface::vertexes</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Vector of vertexes associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Derived classes must use this vector if bounding boxes and transforms are to be applied. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_surface_8hpp_source.html">Surface.hpp</a></li>
<li>src/<a class="el" href="_surface_8cpp.html">Surface.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_surface.html">Surface</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
